diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/city.c freeciv-patched/common/city.c
--- freeciv-cvs/common/city.c	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/city.c	2003-06-30 12:18:17.000000000 +0100
@@ -2029,9 +2320,10 @@
 	happy_cost = 0;
       }
     }
-    if (happy_cost > 0 && variant == 1 && have_police) {
-      happy_cost--;
-    }
+
+    /* Per-unit modifier (effect of, e.g., Civ2's Police Station) */
+    if (happy_cost <= pcity->makecontentmilper) happy_cost=0;
+    else happy_cost -= pcity->makecontentmilper;
 
     /* subtract values found above from city's resources -- SKi */
     if (happy_cost > 0) {
@@ -2091,9 +2383,16 @@
   add_buildings_effect(pcity);	/* marketplace, library wonders.. */
   set_pollution(pcity);
   citizen_happy_luxury(pcity);	/* with our new found luxuries */
-  citizen_happy_buildings(pcity);	/* temple cathedral colosseum */
-  city_support(pcity, send_unit_info);	/* manage settlers, and units */
-  citizen_happy_wonders(pcity);	/* happy wonders & fundamentalism */
+
+  /* Happy buildings - e.g. temple cathedral colosseum */
+  citizen_happy_buildings(pcity, FALSE);
+
+  /* manage settlers, and units */
+  city_support(pcity, send_unit_info);
+
+  /* Happy Wonders (& Fundamentalism) */
+  citizen_happy_buildings(pcity, TRUE);
+
   unhappy_city_check(pcity);
 
   if (refresh_trade_route_cities && pcity->tile_trade != prev_tile_trade) {
@@ -2140,7 +2439,7 @@
   struct government *g = get_gov_pcity(pcity);
   struct city *capital;
   int dist;
-  int val, trade_penalty;
+  int val, trade_penalty,  corruptadj;
 
   assert(game.notradesize < game.fulltradesize);
   if (pcity->size <= game.notradesize) {
@@ -2170,8 +2469,10 @@
       dist * g->corruption_distance_factor + g->extra_corruption_distance;
   val = trade * dist / g->corruption_modifier;
 
-  if (city_got_building(pcity, B_COURTHOUSE) ||
-      city_got_building(pcity, B_PALACE)) val /= 2;
+  /* Add modifiers from generalised improvements */
+  corruptadj = pcity->corruptadj * pcity->corruptpct / 100;
+  val = val * corruptadj / 100;
+
   val *= g->corruption_level;
   val /= 100;
   val = CLIP(trade_penalty, val, trade);
@@ -2275,36 +2576,107 @@
 **************************************************************************/
 void city_add_improvement(struct city *pcity, Impr_Type_id impr)
 {
-  struct player *pplayer = city_owner(pcity);
+  struct ceff_vector *ceffs[2];
+  struct geff_vector *geffs[4];
+  int i;
 
-  if (improvement_obsolete(pplayer, impr)) {
-    mark_improvement(pcity, impr, I_OBSOLETE);
-  } else {
-    mark_improvement(pcity, impr, I_ACTIVE);
-  }
+  mark_improvement(pcity, impr, I_ACTIVE);
 
-  improvements_update_redundant(pplayer, pcity, 
-                                map_get_continent(pcity->x, pcity->y),
-                                improvement_types[impr].equiv_range);
+  /* Add affects at all ranges. */
+  get_effect_vectors(ceffs, geffs, impr, pcity);
+  for (i = 0; ceffs[i]; i++) {
+    struct eff_city *eff = append_ceff(ceffs[i]);
+    eff->impr = impr;
+    eff->active = 0;
+  }
+  for (i = 0; geffs[i]; i++) {
+    struct eff_global *eff = append_geff(geffs[i]);
+    eff->eff.impr = impr;
+    eff->eff.active = 0;
+    eff->cityid = pcity->id;
+    eff->plr = city_owner(pcity);
+  }
 }
 
 /**************************************************************************
  Removes an improvement (and its effects) from a city, and updates the global
  arrays if the improvement has effects and/or an equiv_range that
  extend outside of the city.
-**************************************************************************/
-void city_remove_improvement(struct city *pcity,Impr_Type_id impr)
-{
-  struct player *pplayer = city_owner(pcity);
+ If "is_destroyed" is TRUE, then the improvement has been destroyed; any
+ effects with "survives" set are to be preserved.
+ N.B. Must call update_all_effects() to resolve dependencies.
+**************************************************************************/
+void city_remove_improvement(struct city *pcity,Impr_Type_id impr,
+			     bool is_destroyed)
+{
+  struct ceff_vector *ceffs[2];
+  struct geff_vector *geffs[4];
+  bool survives = FALSE;
+  int i, j;
   
   freelog(LOG_DEBUG,"Improvement %s removed from city %s",
           improvement_types[impr].name, pcity->name);
-  
   mark_improvement(pcity, impr, I_NONE);
+  
+  /* If the building had a larger equiv_range than just this city, there may
+     be other improvements in the same range - so make sure they are restored */
+  if (improvement_types[impr].equiv_range > EFR_CITY) {
+    players_iterate(pothplayer) {
+      city_list_iterate(pothplayer->cities, pothcity) {
+        if (pothcity->improvements[impr] != I_NONE) {
+           mark_improvement(pothcity, impr, pothcity->improvements[impr]);
+        }
+      } city_list_iterate_end;
+    } players_iterate_end;
+  }
+
+  /* Are there actually any destruction-surviving effects? */
+  if (is_destroyed) {
+    struct impr_effect *imeff;
+    for (imeff = improvement_types[impr].effect;
+	 imeff && imeff->type != EFT_LAST; imeff++) {
+      if (imeff->survives) {
+	survives = TRUE;
+	break;
+      }
+    }
+  }
 
-  improvements_update_redundant(pplayer, pcity,
-                                map_get_continent(pcity->x, pcity->y),
-                                improvement_types[impr].equiv_range);
+  get_effect_vectors(ceffs, geffs, impr, pcity);
+  /* Remove the base city effects */
+  for (j = 0; ceffs[j]; j++) {
+    for (i = 0; i < ceff_vector_size(ceffs[j]); i++) {
+      struct eff_city *eff = ceff_vector_get(ceffs[j], i);
+      if (eff->impr == impr) {
+        eff->impr = B_LAST;
+        break;
+      }
+    }
+  }
+
+  if (survives) {
+    /* Add the effects to the player's "destroyed effects" list */
+    struct eff_city *eff;
+    struct player *pplayer = city_owner(pcity);
+
+    eff = append_ceff(&pplayer->destroyed_effects);
+    eff->impr = impr;
+    eff->active = 0;
+    freelog(LOG_DEBUG, "Effects of %s moved to player's destroyed effects list",
+	    get_improvement_name(impr));
+    game.destroyed_owner[impr] = pplayer;
+  } else {
+    /* Remove the global-range effects */
+    for (j = 0; geffs[j]; ++j) {
+      for (i = 0; i < geff_vector_size(geffs[j]); ++i) {
+        struct eff_global *eff = geff_vector_get(geffs[j], i);
+        if (eff->eff.impr == impr) {
+          eff->eff.impr = B_LAST;
+          break;
+	}
+      }
+    }
+  }
 }
 
 /**************************************************************************
@@ -2412,6 +2784,9 @@
   improvement_status_init(pcity->improvements,
                           ARRAY_SIZE(pcity->improvements));
 
+  /* Initialise city's vector of improvement effects. */
+  ceff_vector_init(&pcity->effects);
+
   pcity->turn_last_built = game.year;
   pcity->changed_from_id = 0;
   pcity->changed_from_is_unit = FALSE;
@@ -2445,5 +2820,8 @@
 **************************************************************************/
 void remove_city_virtual(struct city *pcity)
 {
+  /* Free vector of improvement effects */
+  ceff_vector_free(&pcity->effects);
+
   free(pcity);
 }
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/city.h freeciv-patched/common/city.h
--- freeciv-cvs/common/city.h	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/city.h	2003-06-30 12:18:17.000000000 +0100
@@ -52,6 +52,12 @@
   CITYO_DISBAND, CITYO_NEW_EINSTEIN, CITYO_NEW_TAXMAN
 };
 
+/* Whether this city can build certain "special" units or improvements */
+enum city_flags {
+  CITY_ENABLE_SPACE = 1 << 0,
+  CITY_ENABLE_NUKE  = 1 << 1
+};
+
 /* first four bits are for auto-attack: */
 #define CITYOPT_AUTOATTACK_BITS 0xF
 
@@ -204,6 +210,10 @@
                       * all units coming to kill us. */
 };
 
+struct tile_mod {
+  int trade, shields, food;
+};
+
 struct city {
   int id;
   int owner;
@@ -233,6 +243,32 @@
   int shield_prod, shield_surplus, shield_waste; 
   int trade_prod, corruption, tile_trade;
   int shield_bonus, tax_bonus, science_bonus; /* more CPU savings! */
+  int tithes_bonus;
+
+  /* per tile production bonuses from city improvements */
+  struct tile_mod tile_bonuses[CITY_MAP_SIZE][CITY_MAP_SIZE];
+  struct tile_mod tile_add[CITY_MAP_SIZE][CITY_MAP_SIZE];
+  struct tile_mod tile_pct[CITY_MAP_SIZE][CITY_MAP_SIZE];
+
+  /* combat multipliers for each type of attacker */
+  int defensepct[UCL_LAST + 1];
+  int attackpct[UCL_LAST + 1];
+  int defensefppct[UCL_LAST + 1];
+  int attackfppct[UCL_LAST + 1];
+
+  /* corruption modifiers from city improvements */
+  int corruptadj, corruptpct;
+
+  /* happiness modifiers from city improvements */
+  int makecontent, makehappy, forcecontent, forcehappy;
+  int makecontentmil, makecontentmilper;
+
+  /* pollution modifiers from city improvements */
+  int poppoladj, prodpoladj, poladj;
+
+  /* cost modifiers */
+  int impr_cost_pct;
+  int unit_cost_pct[UCL_LAST + 1];
 
   /* the totals */
   int luxury_total, tax_total, science_total;
@@ -248,6 +284,7 @@
   int currently_building;
   
   Impr_Status improvements[B_LAST];
+  struct ceff_vector effects;
   
   struct worklist worklist;
 
@@ -275,6 +312,13 @@
   int original;			/* original owner */
   int city_options;		/* bitfield; positions as enum city_options */
 
+  enum city_flags buildflags;	/* whether we can build spaceship/nukes */
+  int size_limit;		/* max. population with current improvements */
+  Impr_Type_id unlimit_impr;	/* the improvement that increases size_limit */
+  int nuke_proof;		/* nuclear attacks fail within this range */
+  int growth_food;		/* pct. size of foodbox on growth/shrink */
+  int upkeep_free;		/* improvements with this upkeep are free */
+
   /* server variable. indicates if the city map is synced with the client. */
   bool synced;
     
@@ -432,9 +476,12 @@
 int city_granary_size(int city_size);
 
 void city_add_improvement(struct city *pcity,Impr_Type_id impr);
-void city_remove_improvement(struct city *pcity,Impr_Type_id impr);
+void city_remove_improvement(struct city *pcity, Impr_Type_id impr,
+                             bool is_destroyed);
 
 /* city update functions */
+void update_city_bonuses(struct city *pcity);
+void city_init_tile_mods(struct city *pcity);
 void generic_city_refresh(struct city *pcity,
 			  bool refresh_trade_route_cities,
 			  void (*send_unit_info) (struct player * pplayer,
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/combat.c freeciv-patched/common/combat.c
--- freeciv-cvs/common/combat.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/common/combat.c	2003-06-30 12:17:55.000000000 +0100
@@ -223,12 +223,104 @@
   return accum_prob;
 }
 
+struct impr_eff_unit {
+  int combatpct;
+  int firepowerpct;
+};
+
+static void get_impr_eff_unit(Unit_Type_id att_type,
+			      Unit_Type_id def_type, int x, int y,
+			      struct player *def_player,
+			      struct player *att_player,
+			      bool get_attack,
+			      struct impr_eff_unit *effunit)
+{
+  int combatpct = 100, firepowerpct = 100;
+  struct eff_iter iter;
+  struct map_position mappos;
+  struct city *pcity = map_get_city(x, y);
+  int i;
+
+  mappos.x = x;
+  mappos.y = y;
+
+  if (get_attack) {
+    eff_iterator_unit_init(&iter, att_type, def_type, NULL, &mappos);
+  } else {
+    eff_iterator_unit_init(&iter, def_type, att_type, def_player, &mappos);
+  }
+
+  /* Ignore effects at City-range and greater if we're in a city,
+   * as we already have these effects cached; if the attacking unit
+   * "ignores walls" then we ignore these effects completely. */
+  if (unit_type_flag(att_type, F_IGWALL) || pcity) {
+    for (i = EFR_CITY; i < EFR_LAST; ++i) {
+      iter.effs[i] = NULL;
+    }
+  }
+
+  if (get_attack) {
+    while (eff_iterator_next(&iter)) {
+      switch (iter.imeff->type) {
+      case EFT_UNIT_ATTACK:
+        combatpct = combatpct * iter.imeff->amount / 100;
+        break;
+      case EFT_UNIT_ATTACK_FIREPOWER:
+        firepowerpct = firepowerpct * iter.imeff->amount / 100;
+        break;
+      default:
+	break;
+      }
+    }
+  } else {
+    while (eff_iterator_next(&iter)) {
+      switch (iter.imeff->type) {
+      case EFT_UNIT_DEFEND:
+        combatpct = combatpct * iter.imeff->amount / 100;
+        break;
+      case EFT_UNIT_DEFEND_FIREPOWER:
+        firepowerpct = firepowerpct * iter.imeff->amount / 100;
+        break;
+      default:
+	break;
+      }
+    }
+  }
+
+  /* Apply cached city effects */
+  if (pcity && !unit_type_flag(att_type, F_IGWALL)) {
+    struct unit_classes aff_unit;
+
+    if (get_attack) {
+      get_unittype_classes(def_type, &aff_unit);
+      for (i = 0; i <= UCL_LAST; ++i) {
+	if (i == UCL_LAST || is_unit_class_in_set(i, &aff_unit)) {
+	  combatpct = combatpct * pcity->attackpct[i] / 100;
+	  firepowerpct = firepowerpct * pcity->attackfppct[i] / 100;
+	}
+      }
+    } else {
+      get_unittype_classes(att_type, &aff_unit);
+      for (i = 0; i <= UCL_LAST; ++i) {
+	if (i == UCL_LAST || is_unit_class_in_set(i, &aff_unit)) {
+	  combatpct = combatpct * pcity->defensepct[i] / 100;
+	  firepowerpct = firepowerpct * pcity->defensefppct[i] / 100;
+	}
+      }
+    }
+  }
+  effunit->combatpct = combatpct;
+  effunit->firepowerpct = firepowerpct;
+}
+
 /**************************************************************************
 A unit's effective firepower depend on the situation.
 **************************************************************************/
 void get_modified_firepower(struct unit *attacker, struct unit *defender,
 			    int *att_fp, int *def_fp)
 {
+  struct impr_eff_unit att_effunit, def_effunit;
+
   *att_fp = unit_type(attacker)->firepower;
   *def_fp = unit_type(defender)->firepower;
 
@@ -238,15 +330,29 @@
     *att_fp *= 2;
     *def_fp = 1;
   }
-  
-  /* 
-   * When attacked by fighters, helicopters have their firepower
-   * reduced to 1.
-   */
-  if (is_heli_unit(defender) && unit_flag(attacker, F_FIGHTER)) {
-    *def_fp = 1;
-  }
 
+  /* Effects from generalised improvements */
+  get_impr_eff_unit(attacker->type, defender->type, defender->x, defender->y,
+      		    unit_owner(defender), unit_owner(attacker),
+		    TRUE, &att_effunit);
+  get_impr_eff_unit(attacker->type, defender->type, defender->x, defender->y,
+      		    unit_owner(defender), unit_owner(attacker),
+		    FALSE, &def_effunit);
+
+  freelog(LOG_DEBUG,
+	  "%s attacking %s: impr-gen firepower multiplier %d",
+	  get_unit_type(attacker->type)->name,
+	  get_unit_type(defender->type)->name,
+	  att_effunit.firepowerpct);
+  freelog(LOG_DEBUG,
+	  "%s defending against %s: impr-gen firepower multiplier %d",
+	  get_unit_type(defender->type)->name,
+	  get_unit_type(attacker->type)->name,
+	  def_effunit.firepowerpct);
+
+  *def_fp = *def_fp * def_effunit.firepowerpct / 100;
+  *att_fp = *att_fp * att_effunit.firepowerpct / 100;
+  
   /* In land bombardment both units have their firepower reduced to 1 */
   if (is_sailing_unit(attacker)
       && !is_ocean(map_get_terrain(defender->x, defender->y))
@@ -295,20 +401,6 @@
 }
 
 /**************************************************************************
- a wrapper function that returns whether or not the unit is on a citysquare
- with citywalls
-**************************************************************************/
-bool unit_behind_walls(struct unit *punit)
-{
-  struct city *pcity;
-  
-  if((pcity=map_get_city(punit->x, punit->y)))
-    return city_got_citywalls(pcity);
-  
-  return FALSE;
-}
-
-/**************************************************************************
  a wrapper function returns 1 if the unit is on a square with fortress
 **************************************************************************/
 bool unit_on_fortress(struct unit *punit)
@@ -317,48 +409,20 @@
 }
 
 /**************************************************************************
- a wrapper function returns 1 if the unit is on a square with coastal defense
-**************************************************************************/
-bool unit_behind_coastal(struct unit *punit)
-{
-  struct city *pcity;
-  if((pcity=map_get_city(punit->x, punit->y)))
-    return city_got_building(pcity, B_COASTAL);
-  return FALSE;
-}
-
-/**************************************************************************
- a wrapper function returns 1 if the unit is on a square with sam site
-**************************************************************************/
-bool unit_behind_sam(struct unit *punit)
-{
-  struct city *pcity;
-  if((pcity=map_get_city(punit->x, punit->y)))
-    return city_got_building(pcity, B_SAM);
-  return FALSE;
-}
-
-/**************************************************************************
- a wrapper function returns 1 if the unit is on a square with sdi defense
-**************************************************************************/
-bool unit_behind_sdi(struct unit *punit)
-{
-  struct city *pcity;
-  if((pcity=map_get_city(punit->x, punit->y)))
-    return city_got_building(pcity, B_SDI);
-  return FALSE;
-}
-
-/**************************************************************************
   a wrapper function returns 1 if there is a sdi-defense close to the square
 **************************************************************************/
 struct city *sdi_defense_close(struct player *owner, int x, int y)
 {
-  square_iterate(x, y, 2, x1, y1) {
-    struct city *pcity = map_get_city(x1, y1);
-    if (pcity && (!pplayers_allied(city_owner(pcity), owner))
-	&& city_got_building(pcity, B_SDI)) return pcity;
-  } square_iterate_end;
+  players_iterate(pplayer) {
+    if (pplayer != owner) {
+      city_list_iterate(pplayer->cities, pcity) {
+        if (pcity->nuke_proof > 0
+            && map_distance(pcity->x, pcity->y, x, y) <= pcity->nuke_proof) {
+          return pcity;
+        }
+      } city_list_iterate_end;
+    }
+  } players_iterate_end;
 
   return NULL;
 }
@@ -422,13 +486,25 @@
 }
 
 /***************************************************************************
- return the modified attack power of a unit.  Currently they aren't any
- modifications...
+ return the modified attack power of a unit.
 ***************************************************************************/
 int get_total_attack_power(struct unit *attacker, struct unit *defender)
 {
+  struct impr_eff_unit effunit;
   int attackpower = get_attack_power(attacker);
 
+  /* Effects from generalised improvements */
+  get_impr_eff_unit(attacker->type, defender->type, attacker->x, attacker->y,
+      		    unit_owner(defender), unit_owner(attacker),
+		    TRUE, &effunit);
+
+  freelog(LOG_DEBUG,
+	  "%s attacking %s: impr-gen multiplier %d",
+	  get_unit_type(attacker->type)->name,
+	  get_unit_type(defender->type)->name,
+	  effunit.combatpct);
+  attackpower = attackpower * effunit.combatpct / 100;
+
   return attackpower;
 }
 
@@ -444,45 +520,24 @@
 **************************************************************************/
 static int defence_multiplication(Unit_Type_id att_type,
 				  Unit_Type_id def_type, int x, int y,
-				  int defensepower, bool fortified)
+				  int defensepower, bool fortified,
+				  struct player *att_player,
+				  struct player *def_player)
 {
   struct city *pcity = map_get_city(x, y);
 
   if (unit_type_exists(att_type)) {
-    if (unit_type_flag(def_type, F_PIKEMEN)
-	&& unit_type_flag(att_type, F_HORSE)) {
-      defensepower *= 2;
-    }
+    /* Effects from generalised improvements */
+    struct impr_eff_unit effunit;
 
-    if (unit_type_flag(def_type, F_AEGIS) &&
-	(is_air_unittype(att_type) || is_heli_unittype(att_type))) {
-      defensepower *= 5;
-    }
-         
-    if (is_air_unittype(att_type) && pcity) {
-      if (city_got_building(pcity, B_SAM)) {
-	defensepower *= 2;
-      }
-      if (city_got_building(pcity, B_SDI)
-	  && unit_type_flag(att_type, F_MISSILE)) {
-	defensepower *= 2;
-      }
-    } else if (is_water_unit(att_type) && pcity) {
-      if (city_got_building(pcity, B_COASTAL)) {
-	defensepower *= 2;
-      }
-    }
-    if (!unit_type_flag(att_type, F_IGWALL)
-	&& (is_ground_unittype(att_type) || is_heli_unittype(att_type)
-	    || (improvement_variant(B_CITY) == 1
-		&& is_water_unit(att_type))) && pcity
-	&& city_got_citywalls(pcity)) {
-      defensepower *= 3;
-    }
+    get_impr_eff_unit(att_type, def_type, x, y, def_player, att_player,
+		      FALSE, &effunit);
 
-    if (unit_type_flag(att_type, F_FIGHTER) && is_heli_unittype(def_type)) {
-      defensepower /= 2;
-    }
+    freelog(LOG_DEBUG,
+	    "%s defending against %s: impr-gen multiplier %d",
+	    get_unit_type(def_type)->name,
+	    get_unit_type(att_type)->name, effunit.combatpct);
+    defensepower = defensepower * effunit.combatpct / 100;
   }
 
   if (map_has_special(x, y, S_FORTRESS) && !pcity) {
@@ -523,8 +578,10 @@
     defensepower = (defensepower * 3) / 2;
   }
 
+  /* FIXME: we don't know the player, so can't consider Player-range
+   * Unit_Defend improvement effects... */
   return defence_multiplication(att_type, def_type, x, y, defensepower,
-				fortified);
+				fortified, NULL, NULL);
 }
 
 /***************************************************************************
@@ -537,7 +594,8 @@
   return defence_multiplication(attacker->type, defender->type,
 				defender->x, defender->y,
 				get_defense_power(defender),
-				defender->activity == ACTIVITY_FORTIFIED);
+				defender->activity == ACTIVITY_FORTIFIED,
+				unit_owner(attacker), unit_owner(defender));
 }
 
 /**************************************************************************
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/combat.h freeciv-patched/common/combat.h
--- freeciv-cvs/common/combat.h	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/common/combat.h	2003-06-30 12:16:57.000000000 +0100
@@ -38,11 +38,7 @@
 double unit_win_chance(struct unit *attacker, struct unit *defender);
 
 bool unit_really_ignores_citywalls(struct unit *punit);
-bool unit_behind_walls(struct unit *punit);
 bool unit_on_fortress(struct unit *punit);
-bool unit_behind_coastal(struct unit *punit);
-bool unit_behind_sam(struct unit *punit);
-bool unit_behind_sdi(struct unit *punit);
 struct city *sdi_defense_close(struct player *owner, int x, int y);
 
 int get_attack_power(struct unit *punit);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/game.c freeciv-patched/common/game.c
--- freeciv-cvs/common/game.c	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/game.c	2003-06-30 12:18:03.000000000 +0100
@@ -619,10 +619,21 @@
 **************************************************************************/
 void game_remove_city(struct city *pcity)
 {
+  int i;
+
+  /* Update list of destroyed wonders properly */
+  for (i = 0; i < B_LAST; i++) {
+    if (game.global_wonders[i] == pcity->id) {
+      game.global_wonders[i] = -1;
+    }
+  }
+
   freelog(LOG_DEBUG, "game_remove_city %d", pcity->id);
   freelog(LOG_DEBUG, "removing city %s, %s, (%d %d)", pcity->name,
 	   get_nation_name(city_owner(pcity)->nation), pcity->x, pcity->y);
 
+  ceff_vector_free(&pcity->effects);
+
   city_map_checked_iterate(pcity->x, pcity->y, x, y, mx, my) {
     set_worker_city(pcity, x, y, C_TILE_EMPTY);
   } city_map_checked_iterate_end;
@@ -699,6 +710,12 @@
   game.nbarbarians = 0;
   game.occupychance= GAME_DEFAULT_OCCUPYCHANCE;
 
+  geff_vector_init(&game.effects);
+  ceff_vector_init(&game.destroyed_effects);
+  for (i = 0; i < B_LAST; i++) {
+    game.destroyed_owner[i] = NULL;
+  }
+
   game.heating     = 0;
   game.cooling     = 0;
   sz_strlcpy(game.save_name, GAME_DEFAULT_SAVE_NAME);
@@ -715,6 +732,7 @@
 
   sz_strlcpy(game.rulesetdir, GAME_DEFAULT_RULESETDIR);
 
+  game.num_unit_flags = F_LAST;
   game.num_unit_types = 0;
   game.num_impr_types = 0;
   game.num_tech_types = 0;
@@ -774,6 +792,8 @@
 ***************************************************************/
 void game_free(void)
 {
+  geff_vector_free(&game.effects);
+  ceff_vector_free(&game.destroyed_effects);
   game_remove_all_players();
   map_free();
   idex_free();
@@ -882,6 +902,8 @@
     pplayer->attribute_block.data = NULL;
   }
 
+  geff_vector_free(&pplayer->effects);
+  ceff_vector_free(&pplayer->destroyed_effects);
   if (pplayer->island_improv) {
     free(pplayer->island_improv);
     pplayer->island_improv = NULL;
@@ -1023,3 +1045,142 @@
 #undef name_strlcpy
 
 }
+
+/***************************************************************
+  Marks all effects in the given vector as inactive.
+***************************************************************/
+static void deactivate_effects(struct ceff_vector *ceff)
+{
+  int i, efflen;
+
+  assert(ceff != NULL);
+  efflen = ceff_vector_size(ceff);
+  for (i = 0; i < efflen; ++i) {
+    struct eff_city *effect = ceff_vector_get(ceff, i);
+    effect->active = 0;
+  }
+}
+
+/***************************************************************
+  Marks all effects in all effect vectors as inactive.
+***************************************************************/
+static void deactivate_all_effects(void)
+{
+  deactivate_effects(get_geff_parent(get_eff_world()));
+  deactivate_effects(&game.destroyed_effects);
+
+  players_iterate(pplayer) {
+    int contid;
+
+    deactivate_effects(get_geff_parent(get_eff_player(pplayer)));
+    for (contid = 1; contid <= map.num_continents; ++contid) {
+      deactivate_effects(get_geff_parent(get_eff_island(contid, pplayer)));
+    }
+    city_list_iterate(pplayer->cities, pcity) {
+      deactivate_effects(get_eff_city(pcity));
+    } city_list_iterate_end;
+    deactivate_effects(&pplayer->destroyed_effects);
+  } players_iterate_end;
+
+  freelog(LOG_DEBUG, "All effects deactivated");
+}
+
+/***************************************************************
+  Mark as active all relevant effects in the given effect
+  vector.
+***************************************************************/
+static void update_city_effects(struct ceff_vector *ceff, struct city *pcity,
+				struct player *pplayer,
+				bool *cond_eff, bool *changed)
+{
+  int i;
+
+  for (i = 0; i < ceff_vector_size(ceff); i++) {
+    struct eff_city *effect = ceff_vector_get(ceff, i);
+
+    /* Consider the effects of all active improvements */
+    if (effect->impr != B_LAST
+        && (!pcity || pcity->improvements[effect->impr] == I_ACTIVE)) {
+      Eff_Status testbit;
+      struct impr_effect *imeff = get_base_effect(effect->impr, pplayer);
+      bool this_changed = FALSE;
+
+      for (testbit = 1;
+           imeff && imeff->type != EFT_LAST;
+           imeff++, testbit <<= 1) {
+
+        /* Do not activate destroyed effects that do not "survive" */
+        if (!pcity && !imeff->survives) {
+          freelog(LOG_DEBUG,
+                  "Not activating non-surviving destroyed effect %s (from %s)",
+                  effect_type_name(imeff->type),
+		  get_effect_cause_name(effect->impr, pplayer));
+
+        /* Do nothing if the effect is already active */
+        } else if (effect->active & testbit) {
+          freelog(LOG_DEBUG,"Effect %s (from %s) already active in %s",
+                  effect_type_name(imeff->type),
+		  get_effect_cause_name(effect->impr, pplayer),
+                  pcity ? pcity->name : "destroyed city");
+
+        /* Test to see if the effect is activated by prerequisites */
+        } else if (is_effect_activated(effect->impr, pcity, pplayer,
+                                       imeff, cond_eff)) {
+          freelog(LOG_DEBUG,"Effect %s (from %s) active in %s!",
+                  effect_type_name(imeff->type),
+		  get_effect_cause_name(effect->impr, pplayer),
+                  pcity ? pcity->name : "destroyed city");
+          effect->active |= testbit;
+          this_changed = *changed = TRUE;
+        }
+      }
+
+      /* Sync wide-range effect structures with the city structure */
+      if (this_changed) {
+        update_global_effect(pcity, pplayer, effect);
+      }
+    }
+  }
+}
+
+/***************************************************************
+  Update all improvement effects.
+***************************************************************/
+void update_all_effects(void)
+{
+  bool changed, cond_eff;
+
+  improvements_update_obsolete();
+  improvements_update_redundant(NULL, NULL, 0, IR_WORLD);
+
+  deactivate_all_effects();
+
+  /* We may need to loop several times, if some effects are dependent on other
+   * effects (cond_eff=TRUE) _and_ one or more effects (which may satisfy this
+   * dependency) were activated in this pass (changed=TRUE) */
+  do {
+    changed = cond_eff = FALSE;
+    freelog(LOG_DEBUG, "Effect test pass");
+    players_iterate(pplayer) {
+      city_list_iterate(pplayer->cities, pcity) {
+	struct ceff_vector *ceff = get_eff_city(pcity);
+	update_city_effects(ceff, pcity, pplayer, &cond_eff, &changed);
+      } city_list_iterate_end;
+
+      /* Update all effects of this player's destroyed Wonders */
+      update_city_effects(&pplayer->destroyed_effects, NULL, pplayer,
+			  &cond_eff, &changed);
+    } players_iterate_end;
+
+    /* Update all effects of destroyed Wonders that belonged to
+     * now-dead players */
+    update_city_effects(&game.destroyed_effects, NULL, NULL,
+			&cond_eff, &changed);
+  } while (changed && cond_eff);
+
+  players_iterate(pplayer) {
+    city_list_iterate(pplayer->cities, pcity) {
+      update_city_bonuses(pcity);
+    } city_list_iterate_end;
+  } players_iterate_end;
+}
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/game.h freeciv-patched/common/game.h
--- freeciv-cvs/common/game.h	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/game.h	2003-06-30 12:18:10.000000000 +0100
@@ -106,9 +106,14 @@
   struct conn_list game_connections;       /* involved in game; send map etc */
   int global_advances[A_LAST];             /* a counter */
   int global_wonders[B_LAST];              /* contains city id's */
-         /* global_wonders[] may also be (-1), or the id of a city
-	    which no longer exists, if the wonder has been destroyed */
+      /* global_wonders[] may also be (-1) if the wonder has been destroyed */
+  struct player *destroyed_owner[B_LAST];  /* the player that owns each
+					    * destroyed Wonder */
   Impr_Status improvements[B_LAST];        /* impr. with equiv_range==World */
+  struct geff_vector effects;              /* effects with range==World */
+  struct ceff_vector destroyed_effects;    /* list of effects that have
+                                            * survived building and
+					    * player destruction */
 
   int heating; /* Number of polluted squares. */
   int globalwarming; /* Total damage done. (counts towards a warming event.) */
@@ -143,6 +148,7 @@
   bool fogofwar_old;	/* as the fog_of_war bit get changed by setting
 			   the server we need to remember the old setting */
 
+  int num_unit_flags;
   int num_unit_types;
   int num_impr_types;
   int num_tech_types;  /* including A_NONE */
@@ -160,6 +166,9 @@
   int watchtower_vision;
   int allowed_city_names;
 
+  /* Bonuses that affect all cities */
+  int science_bonus, tax_bonus;
+
   char rulesetdir[MAX_LEN_NAME];
   int firepower_factor;		/* See README.rulesets */
   struct {
@@ -253,6 +262,7 @@
 
 struct player *get_player(int player_id);
 int get_num_human_and_ai_players(void);
+void update_all_effects(void);
 
 extern struct civ_game game;
 extern bool is_server;
